# Provision OIDC client secret for Grafana, if not existing in cluster

- name: Get grafana oauth secret
  kubernetes.core.k8s_info:
    api_version: v1
    kind: Secret
    name: "grafana-oauth"
    namespace: "{{ config.grafana.namespace }}"
  register: k8s_secret

- name: load existing secret
  set_fact:
    grafana_oauth_client_secret: "{{ k8s_secret.resources[0].data['oauth_secret'] | b64decode }}"
  when: k8s_secret.resources.0 is defined

- name: load grafana OIDC client secret
  set_fact:
    grafana_oauth_client_secret: "{{ config.grafana.keycloak_client_secret }}"
  when: k8s_secret.resources.0 is not defined and config.grafana.keycloak_client_secret is defined

- name: generate new Grafana OAuth client secret
  set_fact:
    grafana_oauth_client_secret: "{{ 10000000000000000 | random | to_uuid }}"
  when: grafana_oauth_client_secret is not defined

- name: save new secret as K8s secret
  shell: |
    kubectl create secret -n {{ config.grafana.namespace }} generic grafana-oauth --from-literal=oauth_secret={{ grafana_oauth_client_secret }}
  when: k8s_secret.resources.0 is not defined

- name: Set client id 
  set_fact:
    client_id: "{{ config.system.cluster_name }}-grafana-community"

- name: Grafana OIDC client
  include_role:
    name: common/keycloak
    tasks_from: keycloak_client.yml
  vars:
    clientId: "{{ client_id }}"
    client_definition:
        clientId: "{{ client_id }}"
        name: "{{ client_id }}"
        secret: "{{ grafana_oauth_client_secret }}"
        description: 'Grafana client'
        baseUrl: "https://{{ config.grafana.fqdn }}"
        redirectUris: [ "https://{{ config.grafana.fqdn }}/*" ]
        directAccessGrantsEnabled: true
        protocolMappers:
          - config:
              full.path: True
              id.token.claim: True
              access.token.claim: True
              claim.name: "groups"
              userinfo.token.claim: True
            name: groups
            consentRequired: false
            protocol: openid-connect
            protocolMapper: "oidc-group-membership-mapper"

